//
// ScrollViewEntry.cpp
// Implementation for TScrollViewEntry class
//

#include <stdio.h>
#include <string>
#include "ScrollViewEntry.h"

enum {
	PMI_ABOUT = 'ham!'
};

//
// TScrollViewEntry implementation
//
TComponent *TScrollViewEntry::CreateComponent(BView *view, TFormDesigner *designer, BRect rect)
{
	TDesignScrollView *ScrollView = new TDesignScrollView(rect, "ScrollView", "ScrollView", designer);
	ScrollView->SetClassName(ClassName());
	
	view->LockLooper();
	view->AddChild(ScrollView);
	view->UnlockLooper();
	return ScrollView;
}

//
// TDesignScrollView implementation
//
TDesignScrollView::TDesignScrollView(BRect frame, const char *name, const char *caption, TFormDesigner *designer)
:	BScrollView(name, 0, B_FOLLOW_LEFT|B_FOLLOW_TOP,0,true,true)
, TControlComponent(0, designer, ctVisual)
{
	SetComponentName(name);
	SetDTView(this); // ALWAYS do this
	InitPropertyList(); // and this
	InitPropertyValues();
	InitEventList();
	InitEventValues();
	
}

void TDesignScrollView::MouseDown(BPoint pt)
{
	BScrollView::MouseDown(pt);
	DesignerMouseDown(pt, Bounds(), this);
	Invalidate();
}

void TDesignScrollView::Draw(BRect updateRect)
{
	BScrollView::Draw(updateRect);
	DesignerDrawSelection();
}

bool TDesignScrollView::AddComponentContextMenuItems(BPopUpMenu *menu)
{
	return true;
}

bool TDesignScrollView::HandleComponentContextMessage(BMessage *message)
{
	switch(message->what)
	{
		default: 
			return false;
	}
}

bool TDesignScrollView::DefaultEditAction(BPoint pt)
{
	return false;
}

const char *TDesignScrollView::GetPropertyValue(const char *propName) const
{
	string s = propName;
	
	return TControlComponent::GetPropertyValue(propName);
}

void TDesignScrollView::SetPropertyValue(const char *propName, const char *value)
{
	printf("TDesignScrollView::SetPropertyValue('%s', '%s')\n", propName, value);
	if((!propName) || (!value)) return;
	
	string s = propName,
				 v = value;
	
	TControlComponent::SetPropertyValue(propName, value);
}

void TDesignScrollView::InitPropertyList(void)
{
	TControlComponent::InitPropertyList();
}

void TDesignScrollView::InitEventList(void)
{
	TControlComponent::InitEventList();
}

void TDesignScrollView::InitPropertyValues(void)
{
	TControlComponent::InitPropertyValues();
	SetPropertyValue("ViewColor", "{255,255,255,0}");
}

void TDesignScrollView::InitEventValues(void)
{
	TControlComponent::InitEventValues();
}

void TDesignScrollView::MessageReceived(BMessage *message)
{
	if(!HandleComponentDesignMessage(message))
	{
		BScrollView::MessageReceived(message);
	}
}

void TDesignScrollView::OnSetConstructorParams(BString &s)
{
	TControlComponent::OnSetConstructorParams(s);	
}


// eof
