//
// MyComponent.h
// Proof-of-concept test component
//

#ifndef _MyComponent
#define _MyComponent

class MyComponent: public BButton, public TComponent {
public:
	MyComponent(TComponent *Owner, BRect frame, const char *name, const char *caption)
	:	BButton(frame, name, caption)
	,	TComponent(Owner)
	{
		SetName(name);
	}
	
	// overrides to make this component work.
	virtual const char *GetPropertyValue(const char *propName) const 
	{
		// if the specified property is the "Name" property,
		if(0 == stricmp("Name", propName))
		{
			// Set the name property. Viola.
			return Name();
		}
	
		if(0 == stricmp("Caption", propName))
		{
			// Return the caption via BButton.
			return Label();
		}
	}
	
	// Set the property value (converting from text if nec.) for the property
	// referenced by "propName"
	virtual void SetPropertyValue(const char *propName, const char *value)
	{
		// if the specified property is the "Name" property,
		if(0 == stricmp("Name", propName))
		{
			// Set the name property. Viola.
			SetName(value);
		}
	
		if(0 == stricmp("Caption", propName))
		{
			// Set the caption via BButton::SetCaption()
			SetLabel(value);
		}
		
		if(0 == stricmp("Enabled", propName))
		{
			if(cmRuntime == Mode())
			{
				bool enabled = (0 == stricmp("True", value));
				SetEnabled(enabled);
			}
		}
	}
	
	// Load the list of properties for this component
	virtual void InitPropertyList(void)
	{
		// Load the default properties
		TComponent::InitPropertyList();
	}
	
	// Load the list of events for this component
	virtual void InitEventList(void)
	{
	}

};

#endif // _MyComponent